#include "vtcpnet.h"
//---------------------------------------------------------------------
int32 VTcpNetworkClient::vtcp_rec_thread(void *Dummy)
{
    int sock;
    BLooper *Owner;
    struct timeval tv;
    struct fd_set fds;
    BMessage *sendmsg;
    unsigned char buf[1024];
    ssize_t rec;
    RecThreadData rdata;
    int32 sender;
    int32 code;	

    code=receive_data((thread_id *)&sender,(void *)&rdata,sizeof(rdata));
    Owner=rdata.owner;
    sock=rdata.sock;
	
    do{
        do{
            tv.tv_sec=2;
            tv.tv_usec=0;
            FD_ZERO(&fds);
	        FD_SET(sock,&fds);
            select(32,&fds,NULL,NULL,&tv);
        } while(FD_ISSET(sock,&fds)==0);

       	rec=recv(sock,buf,sizeof(buf),0);
        if(rec<=0)
        {
            sendmsg=new BMessage(MSG_VTCP_CLOSED);
            sendmsg->AddInt32("socket",sock);
			
            Owner->PostMessage(sendmsg);
            delete sendmsg;	
        }
        else
        {
            sendmsg=new BMessage(MSG_VTCP_RECV);
            sendmsg->AddInt32("socket",sock);
            sendmsg->AddData("data",B_ANY_TYPE,(void *)buf,rec);

            Owner->PostMessage(sendmsg);
            delete sendmsg;	
        }
    } while(rec>0);

    return rec;
}
//---------------------------------------------------------------------
VTcpNetworkClient::VTcpNetworkClient(BLooper *Owner)
{
	MyOwner=Owner;
	
	recthread=-1;
	nsock=-1;
	threadname[0]='\0';
}
//---------------------------------------------------------------------
VTcpNetworkClient::~VTcpNetworkClient(void)
{
	sock_closed();
}
//---------------------------------------------------------------------
int VTcpNetworkClient::sock_connect(char *host,int port)
{
    struct sockaddr_in sa;
    int r;

    nsock=socket(AF_INET, SOCK_STREAM, 0);
    sa.sin_family=AF_INET;
    sa.sin_port=htons((short)port);
    sa.sin_addr.s_addr=inet_addr(host);
    if(sa.sin_addr.s_addr==0xFFFFFFFFul)
    {
    	hostent *h;
    	
    	h=gethostbyname(host);
    	if(h!=NULL)
    	   	sa.sin_addr.s_addr=*(unsigned int *)h->h_addr;
    }
    memset(sa.sin_zero,0,sizeof(sa.sin_zero));
    r=connect(nsock,(struct sockaddr *)&sa,sizeof(sa));

    if(r!=-1)
    {
		struct RecThreadData rdata;
		
		rdata.sock=nsock;
		rdata.owner=MyOwner;
		if(MakeThreadName("ClientRecvThread",threadname))
		{
			recthread=spawn_thread(vtcp_rec_thread,threadname,
			                    B_NORMAL_PRIORITY,NULL);
			send_data(recthread,63,(void *)&rdata,sizeof(rdata));
			resume_thread(recthread);
		}
		else
		{
			closesocket(nsock);
			nsock=-1; 
		}
	}
	else
	{
		closesocket(nsock);
		nsock=-1; 
	}
	
	return nsock;
}
//---------------------------------------------------------------------
int VTcpNetworkClient::sock_send(void *data,int32 length)
{
	int r;
	
	r=send(nsock,data,length,0);
	if(r==-1)
	{
		sock_closed();

        BMessage *sendmsg=new BMessage(MSG_VTCP_CLOSED);
        sendmsg->AddInt32("socket",nsock);
			
        MyOwner->PostMessage(sendmsg);
        delete sendmsg;	
	}
	return r;
}
//---------------------------------------------------------------------
void VTcpNetworkClient::sock_closed(void)
{
	int32 fthread;
	
    if(nsock!=-1)
    {
    	closesocket(nsock);
    	nsock=-1;
    }

   	if(strlen(threadname)>0)
   		if((fthread=find_thread(threadname))!=B_NAME_NOT_FOUND)
        {
            kill_thread(fthread);
            threadname[0]='\0';
        }
}
//---------------------------------------------------------------------
int VTcpNetworkClient::sock_accept(int s)
{
	struct sockaddr_in sa;
	int sa_size;
    
    sa.sin_family=AF_INET;
    memset(sa.sin_zero,0,sizeof(sa.sin_zero));
	sa_size=sizeof(sa);
	nsock=accept(s,(struct sockaddr *)&sa, &sa_size); 

	if(nsock!=-1)
	{
		struct RecThreadData rdata;
		
		rdata.sock=nsock;
		rdata.owner=MyOwner;
		if(MakeThreadName("ServerRecvThread",threadname))
		{
			recthread=spawn_thread(vtcp_rec_thread,threadname,
			                    B_NORMAL_PRIORITY,NULL);
			send_data(recthread,63,(void *)&rdata,sizeof(rdata));
			resume_thread(recthread);
		}
		else
		{
			closesocket(nsock);
			nsock=-1; 
			return -1;
		} 
	}
	
	return nsock;
}
//---------------------------------------------------------------------
bool VTcpNetworkClient::MakeThreadName(char *name,char *des)
{
	char wk[33];
	static int i=0;
	
	for(;i<1024;i++)
	{
		sprintf(wk,"%s%d",name,i);
		if(find_thread(wk)==B_NAME_NOT_FOUND)
		{
			strcpy(des,wk);
			return true;
		}
	}

	return false;
}
//---------------------------------------------------------------------
